<template>
  <div id="testPeriod">
    <table-list
      :tableSets="tableSet"
      :tableData="tableData"
      :navText="navText"
      @addClick="addClick"
      :loading="loading"
      @editInfo="editInfo"
    >
      <template slot="btn" slot-scope="props">
        <el-button type="text" @click="addClick(props.scope.row, 0)"
          >修改</el-button
        >
        <el-button type="text" @click="del(props.scope.row)">删除</el-button>
      </template>
    </table-list>
    <pagination
      :total="total"
      :pageSize="pageSize"
      :currentPage="currentPage"
      @handleSizeChange="handleSizeChange"
      @handleCurrentChange="handleCurrentChange"
    />
    <el-dialog
      @closed="loadingClose"
      :visible.sync="dialogVisible"
      width="680px"
      :show-close="false"
      :close-on-click-modal="false"
    >
      <div slot="title" class="hearders">
        <div class="leftTitle">
          {{ statusPop === 1 ? "添加" : statusPop === 0 ? "修改" : "详情" }}
        </div>
        <div class="rightBoxs">
          <img src="@/assets/images/Close@2x.png" alt="" @click="close" />
        </div>
      </div>
      <div>
        <el-form
          label-position="right"
          label-width="110px"
          :model="listData"
          :rules="rules"
          ref="listData"
        >
          <el-form-item
            v-for="(items, indexs) in listitem"
            :key="indexs"
            :label="items.label"
            :prop="items.scope === 'periodTime' ? '' : items.prop"
            :required="items.scope === 'periodTime'"
          >
            <el-radio-group
              v-if="items.scope === 'status'"
              v-model="listData[items.prop]"
            >
              <el-radio
                v-for="(item, index) in items.options"
                :key="index"
                :label="item.value"
                :disabled="statusPop === 2"
                >{{ item.label }}</el-radio
              >
            </el-radio-group>
            <el-select
              v-model="listData[items.prop]"
              filterable
              placeholder="请选择教育类型"
              v-else-if="items.prop === 'educationId'"
              @change="changeJYList"
            >
              <el-option
                v-for="item in optionsSF"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              >
              </el-option>
            </el-select>
            <el-select
              v-model="listData[items.prop]"
              filterable
              placeholder="请选择项目类型"
              v-else-if="items.prop === 'projectId'"
              @change="changeXMList(listData)"
            >
              <el-option
                v-for="item in optionsXM"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              >
              </el-option>
            </el-select>
            <el-input
              :disabled="statusPop === 2"
              v-else-if="items.scope === 'textarea'"
              type="textarea"
              v-model="listData[items.prop]"
            ></el-input>
            <div v-else-if="items.scope === 'periodTime'">
              <el-col :span="11">
                <el-form-item :prop="items.prop1">
                  <el-date-picker
                    v-model="listData[items.prop1]"
                    type="date"
                    format="yyyy 年 MM 月 dd 日"
                    value-format="timestamp"
                    placeholder="选择开始日期"
                    @change="startTimes"
                  >
                  </el-date-picker>
                </el-form-item>
              </el-col>
              <el-col class="line" :span="2">至</el-col>
              <el-col :span="11">
                <el-form-item :prop="items.prop2">
                  <el-date-picker
                    v-model="listData[items.prop2]"
                    type="date"
                    format="yyyy 年 MM 月 dd 日"
                    value-format="timestamp"
                    placeholder="选择结束日期"
                    @change="endTimes"
                  >
                  </el-date-picker>
                </el-form-item>
              </el-col>
            </div>
            <el-input
              class="numInputs"
              :disabled="statusPop === 2"
              v-else-if="items.scope === 'numType'"
              type="age"
              v-model.number="listData[items.prop]"
              ><template slot="append">{{ items.ch }}</template></el-input
            >
            <el-input
              :disabled="statusPop === 2"
              v-else
              v-model="listData[items.prop]"
            ></el-input>
          </el-form-item>
        </el-form>
      </div>
      <span slot="footer" class="dialog-footer">
        <el-button @click="close">取 消</el-button>
        <el-button
          type="primary"
          v-if="statusPop !== 2"
          :loading="disabledBtn"
          @click="submit('listData')"
          >确 定</el-button
        >
      </span>
    </el-dialog>
  </div>
</template>

<script>
import searchBox from "@/components/searchBox";
import tableList from "@/components/tableList";
import pagination from "@/components/pagination";
export default {
  name: "TestPeriod",
  components: { searchBox, tableList, pagination },
  data() {
    return {
      disabledBtn: false,
      loading: false, //当前表单加载是否加载动画
      navText: {
        title: "考期",
        index: 0,
        ch: "条",
        num: true,
        choice: true,
        addHide: false,
        backFatherBtn: {
          status: false,
          title: "未定义",
        },
      },
      // 表单
      tableSet: [
        {
          label: "考期编码",
          prop: "encoder",
          hidden: true,
        },
        {
          label: "考期名称",
          prop: "examineName",
          hidden: true,
          scope: "editInfo",
        },
        {
          label: "入学年份",
          prop: "enrollmentYear",
          hidden: true,
        },
        {
          label: "项目类型",
          prop: "projectName",
          hidden: true,
        },
        {
          label: "有效期",
          prop1: "startTime",
          prop2: "endTime",
          scope: "TimeLists",
          hidden: true,
          Diszing: false,
        },
        {
          label: "状态",
          prop: "status",
          hidden: true,
          scope: "status",
          width: "130px",
        },
      ],
      tableData: [], //表单数据
      total: 0, //一共多少条
      pageSize: 10, //每页多少条数据
      currentPage: 1, //当前页码
      // 弹窗字段
      listitem: [
        {
          label: "教育类型",
          prop: "educationId",
          scope: "select",
        },
        {
          label: "项目类型类型",
          prop: "projectId",
          scope: "select",
        },
        {
          label: "入学年份",
          prop: "enrollmentYear",
          scope: "numType",
          ch: "年",
        },
        {
          label: "考期名称",
          prop: "examineName",
        },
        {
          label: "有效期",
          prop1: "startTime",
          prop2: "endTime",
          scope: "periodTime",
        },
        {
          label: "状态",
          prop: "status",
          scope: "status",
          options: [
            {
              label: "启用",
              value: 1,
            },
            {
              label: "关闭",
              value: 0,
            },
          ],
        },
        {
          label: "备注",
          prop: "remark",
          scope: "textarea",
        },
      ],
      //   弹窗数据
      listData: {},
      statusPop: -1,
      dialogVisible: false,
      optionsSF: [], //教育类型
      optionsXM: [], //项目类型
      //表单验证
      rules: {
        educationId: [
          {
            required: true,
            message: "请选择教育类型",
            trigger: ["blur", "change"],
          },
        ],
        projectId: [
          {
            required: true,
            message: "请选择项目类型",
            trigger: ["blur", "change"],
          },
        ],
        startTime: [
          {
            type: "date",
            required: true,
            message: "请选择开始日期",
            trigger: "change",
          },
        ],
        endTime: [
          {
            type: "date",
            required: true,
            message: "请选择结束日期",
            trigger: "change",
          },
        ],
        examineName: [
          { required: true, message: "请输入考期名称", trigger: "blur" },
        ],
        enrollmentYear: [
          { required: true, message: "学年不能为空" },
          { type: "number", message: "学年必须为数字值" },
        ],
        status: [{ required: true, message: "请选择状态", trigger: "change" }],
      },
    };
  },
  mounted() {
    this.search();
  },
  activated(){
    this.search();
  },
  methods: {
    loadingClose() {
      this.disabledBtn = false;
    },
    startTimes(time) {
      if (this.listData.endTime) {
        if (time > this.listData.endTime) {
          this.$message.warning("开始时间不得大于结束时间");
          this.listData.startTime = "";
        }
      }
    },
    endTimes(time) {
      if (this.listData.startTime) {
        if (time < this.listData.startTime) {
          this.$message.warning("结束时间不得小于开始时间");
          this.listData.endTime = "";
        }
      }
    },
    changeXMList(option) {
      if (!option.educationId) {
        this.optionsXM.map((item, index) => {
          if (item.value === option.projectId) {
            this.listData.educationId = item.pid;
          }
        });
      }
    },
    changeJYList() {
      if (this.listData.projectId) {
        this.listData.projectId = "";
        this.listData.projectName = "";
      }
      this.getXMType(this.listData.educationId);
    },
    editInfo(v) {
      this.addClick(v, 0);
    },
    getEduType() {
      this.$api.inquireCourseEducationType({ status: 1 }).then((res) => {
        var arrays = [];
        res.rows.map((item, index) => {
          arrays.push({
            label: item.educationName,
            value: item.id,
          });
        });
        this.optionsSF = arrays;
      });
    },
    getXMType(id) {
      this.$api
        .inquireCourseProjectType({
          status: 1,
          educationId: id ? id : undefined,
        })
        .then((res) => {
          var arrays = [];
          res.rows.map((item, index) => {
            arrays.push({
              label: item.projectName,
              value: item.id,
              pid: item.educationId,
            });
          });
          this.optionsXM = arrays;
        });
    },
    search(v) {
      this.loading = true;
      var data = {
        status: "0,1",
        pageSize: this.pageSize,
        pageNum: this.currentPage,
      };
      this.$api
        .inquireCourseExamine(data)
        .then((res) => {
          this.tableData = res.rows;
          this.total = res.total;
          this.navText.index = res.total;
        })
        .finally(() => {
          this.loading = false;
        });
    },
    init() {
      this.search();
    },
    del(v) {
      this.$alert(
        "确定删除此内容？<br />内容删除后将无法恢复，请慎重考虑",
        "提示",
        {
          dangerouslyUseHTMLString: true,
        }
      )
        .then(() => {
          var data = {
            id: v.id,
            status: -1,
          };
          this.$api.editCourseExamine(data).then((res) => {
            this.$message.success("删除成功");
            this.$store.commit("COURSEEXAMINE");
            this.search();
          });
        })
        .catch(() => {
          this.$message({
            type: "info",
            message: "已取消删除",
          });
        });
    },
    addClick(v, int) {
      this.getEduType();
      this.getXMType();
      if (v === undefined) {
        this.statusPop = 1;
        this.listData = {
          status: 1,
        };
      } else {
        this.statusPop = int;
        this.listData = JSON.parse(JSON.stringify(v));
        this.listData.startTime = this.$methodsTools.time10to13(
          this.listData.startTime,
          2
        );
        this.listData.endTime = this.$methodsTools.time10to13(
          this.listData.endTime,
          2
        );
      }
      this.$nextTick(() => {
        this.$refs.listData.clearValidate();
      });
      this.dialogVisible = true;
    },
    submit(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          this.rulesTableSumbit();
        } else {
          return false;
        }
      });
    },
    rulesTableSumbit() {
      var arrs = JSON.parse(JSON.stringify(this.listData));
      arrs.startTime = this.$methodsTools.time10to13(
        this.listData.startTime,
        1
      );
      arrs.endTime = this.$methodsTools.time10to13(this.listData.endTime, 1);
      this.disabledBtn = true;
      if (this.statusPop === 1) {
        this.$api
          .appCourseExamine(arrs)
          .then((res) => {
            this.$message.success("新增成功");
            this.dialogVisible = false;
            this.$store.commit("COURSEEXAMINE");
            this.search();
          })
          .catch(() => {
            this.disabledBtn = false;
          });
      }
      if (this.statusPop === 0) {
        this.$api
          .editCourseExamine(arrs)
          .then((res) => {
            this.$message.success("修改成功");
            this.dialogVisible = false;
            this.$store.commit("COURSEEXAMINE");
            this.search();
          })
          .catch(() => {
            this.disabledBtn = false;
          });
      }
    },
    close() {
      this.dialogVisible = false;
    },
    handleSizeChange(v) {
      this.pageSize = v;
      this.currentPage = 1;
      this.search();
    },
    handleCurrentChange(v) {
      this.currentPage = v;
      this.search();
    },
  },
};
</script>

<style lang="less" scoped>
/deep/.el-button {
  border-radius: 8px;
}
/deep/.el-dialog {
  border-radius: 8px;
  .el-dialog__header {
    padding: 0;
    .hearders {
      height: 40px;
      display: flex;
      align-items: center;
      justify-content: space-between;
      padding: 0px 18px 0px 20px;
      border-bottom: 1px solid #e2e2e2;
      .leftTitle {
        font-size: 14px;
        font-weight: bold;
        color: #2f4378;
      }
      .rightBoxs {
        display: flex;
        align-items: center;
        img {
          width: 14px;
          height: 14px;
          margin-left: 13px;
          cursor: pointer;
        }
      }
    }
  }
  .el-dialog__footer {
    padding: 0;
    .dialog-footer {
      padding: 0px 40px;
      height: 70px;
      border-top: 1px solid #e2e2e2;
      display: flex;
      align-items: center;
      justify-content: flex-end;
    }
  }
}
.imgBox {
  width: 100%;
  // height: 210px;
  border: 1px solid #e2e2e2;
  border-radius: 8px;
  padding: 8px 8px 3px;
  display: flex;
  flex-direction: column;
  align-items: center;
  .imgLabel {
    flex: 1;
    width: 100%;
    border: 1px dotted #e2e2e2;
    color: #999;
    font-size: 14px;
    cursor: pointer;
    border-radius: 8px;
    .msPhoto {
      display: flex;
      justify-content: center;
      align-items: center;
      max-width: 100%;
      max-height: 270px;
      img {
        max-width: 100%;
        max-height: 270px;
      }
    }
    .imgbbx {
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      width: 100%;
      height: 100%;
      i {
        font-weight: bold;
        margin: 14px 0;
        font-size: 24px;
      }
    }
  }
  p {
    margin: 5px 0px;
  }
}
.numInputs {
  width: 150px;
}
</style>

